//------------------------------------------------------------------
//
//------------------------------------------------------------------
extern double CloseAtProfit     = 0;
extern bool   AllSymbols        = true;
extern string CommentFieldToUse = "";
extern int    SlippageForClose  = 3;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   CommentFieldToUse = StringTrimLeft(StringTrimRight(CommentFieldToUse));
   return(0);
}

//
//
//
//
//

int start()
{
   if (CloseAtProfit<=0) return(0);
   
   //
   //
   //
   //
   //

   int    tickets[];   
   int    total       = OrdersTotal();
   double groupProfit = 0;

      for (int i = total-1; i>=0 ; i--)
      {
         if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
         if (!AllSymbols && OrderSymbol()!=Symbol())      continue;
         if (OrderType()!=OP_BUY && OrderType()!=OP_SELL) continue;
         if (CommentFieldToUse!="" && CommentFieldToUse!=StringTrimLeft(StringTrimRight(OrderComment()))) continue;
               total += (OrderProfit()+OrderSwap()+OrderCommission());
               ArrayResize(tickets,ArraySize(tickets)+1);
               tickets[ArraySize(tickets)-1] = OrderTicket();
      }
      if (total>=CloseAtProfit)
      for (i = ArraySize(tickets)-1; i>=0 ; i--)
      {
         bool result = false;
         for (int cnt=3; cnt>0; cnt--)
         {
            if (OrderSelect(tickets[i],SELECT_BY_TICKET,MODE_TRADES))
            {
               if (OrderType()==OP_BUY)
                    result = OrderClose(tickets[i],OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),SlippageForClose,CLR_NONE);
               else result = OrderClose(tickets[i],OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),SlippageForClose,CLR_NONE);
            }               
            if (result) break;
         }            
      }
   return(0);        
}